#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
/*Tabulka*/
/* 1. sloupec 0 - 360, krok zvoli uzivatel */
/* 2. sloupec sin (cislo z 1. sloupce v radianech)*/
/* 3. sloupec ln(cislo z 1. sloupce)*/
double ** vyroba2Dpole(int r, int s)
{
    double **pX;
    int i;
    pX=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
        pX[i]=(double *)malloc(s*sizeof(double));
    return(pX);
}
void uvolni(double **pX, int r)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)pX[i]);
    free((void *)pX);
}
void soubor(double **pA, int r, int s, int k)
{
    FILE *fw;
    char nazev[30],vystup[34],radka[50];
    int i,j,q;
    printf("Zadej jmeno souboru bez pripony: ");
    scanf("%29s",nazev);
    sprintf(vystup,"%s.csv",nazev);
    printf("Data budou ulozena do %s\n",vystup);
    if((fw=fopen(vystup,"w"))==NULL)
    {
        printf("Soubor nelze otevrit");
        exit(-1);
    }
    q=0;
    for(i=0; i<=360; i+=k)      /* i+=k ... i=i+k */
    {
        pA[q][0]=(double)i;
        pA[q][1]=sin(pA[q][0]*M_PI/180);
        if(i==0)
            sprintf(radka,"%5.0f;%10.4f;%10c;\n",pA[q][0],pA[q][1],'-');
        else
        {
            pA[q][2]=log(pA[q][0]);
            sprintf(radka,"%5.0f;%10.4f;%10.4f;\n",pA[q][0],pA[q][1],pA[q][2]);
        }
        printf("%s",radka);
        j=0;
        while(radka[j]!='\0')
        {
            if(radka[j]=='.')
                radka[j]=',';
            j++;
        }
        fprintf(fw,"%s",radka);
        q++;
    }
    if((fclose(fw))==EOF)
    {
        printf("Soubor nelze uzavrit");
        exit(-1);
    }
}
int main()
{
    double **pA;
    int r,s,k;
    printf("Zadej krok: ");
    scanf("%d",&k);
    r=360/k+1;
    s=3;
    pA=vyroba2Dpole(r,s);
    soubor(pA,r,s,k);
    uvolni(pA,r);
    return 0;
}
